<template>
  <div v-if="verModal">
    <div class="row mb-3 justify-content-end">
      <div class="col text-end">
        <button v-if="!verHistorial" type="button" class="btn btn-principal p-1 px-2 me-2" alt="Ver historial de visados"
          title="Ver historial de visados" @click="abrirHistorial()">
          <i class="bi bi-eye-fill fs-7 me-1"></i> Ver historial
        </button>
        <button v-else type="button" class="btn btn-principal p-1 px-2 me-2" alt="Ocultar historial de visados"
          title="Ocultar historial de visados" @click="cerrarHistorial()">
          <i class="bi bi-eye-slash-fill fs-7 me-1"></i> Ocultar historial
        </button>
        <button v-if="verVisar" :disabled='/* !esHabilitadoVisar */ false' type="button" class="btn btn-secondary p-1 px-2 me-2"
          alt="Guardar visado" title="Guardar visado" @click="validar()">
          <i class="bi bi-save fs-7 me-1"></i> Guardar
        </button>
      </div>
    </div>
    <Historial v-show="verHistorial" :id-beca="form.beca!.id_beca" :ver-historial="verHistorial" />
    <div class="row mt-3 text-right text-start">
      <fieldset class="border">
        <legend class="w-auto" style="margin-top: -11px; background-color: white;">
          <b>Datos del visado</b>
        </legend>
        <div class="col">
          <div class="row actualizaBecas p-1 text-start">
            <div class="col-3">
              <label :for="'titulo'" class="form-label-act">T&iacute;tulo:</label>
              <select :disabled='!esHabilitadoVisar' required v-model="form.titulo" class="form-select form-select-sm"
                :id="'titulo'">
                <option :value="null" v-text="'--Seleccione--'"></option>
                <option v-for="titulo in titulosStore.getTitulos()" :key="titulo.id_titulo" :value="titulo"
                  v-text="titulo.d_titulo">
                </option>
              </select>
            </div>
            <div class="col-3">
              <label :for="'mesCertif'" class="form-label-act">Mes Certif.:</label>
              <select :disabled='!esHabilitadoVisar' required v-model="form.mesCertif" class="form-select form-select-sm"
                :id="'mesCertif'">
                <option :value="null" v-text="'--Seleccione--'"></option>
                <option v-for="mesCertif in rangoNumeros(3, 12)" :key="mesCertif" :value="mesCertif"
                  v-text="mesMostrar(mesCertif)">
                </option>
              </select>
            </div>
            <div class="col-5">
              <label :for="'establecimientoCursa'" class="form-label-act">Cursa en:</label>
              <input :disabled='!esHabilitadoVisar' required type="text" v-model="form.beca!.establecimiento_cursa"
                class="form-control form-control-sm" autocomplete="off" :id="'establecimientoCursa'" />
            </div>
          </div>
          <div class="row actualizaBecas p-1">
            <div class="col-3">
              <label :for="'impuPresupuestaria'" class="form-label-act">Imputaci&oacute;n Presupuestaria:</label>
              <select :disabled='!esHabilitadoVisar' required v-model="form.impuPresupuestaria"
                class="form-select form-select-sm" :id="'impuPresupuestaria'">
                <option :value="null" v-text="'--Seleccione--'"></option>
                <option v-for="impuPresupuestaria in impuPresupuestariasStore.getImpuPresupuestarias()"
                  :key="impuPresupuestaria.id_impu_presupuestaria" :value="impuPresupuestaria"
                  v-text="impuPresupuestaria.d_impu_presupuestaria">
                </option>
              </select>
            </div>
            <div class="col-4">
              <label :for="'responsable'" class="form-label-act">Responsable:</label>
              <auto-complete v-model="form.responsable" :elements="solicitantesStore.solicYProyectos" initKey=""
                placeholder="Responsable" :minLength="2" :disabled='!esHabilitadoVisar' autocomplete="off"
                :id="'responsable'" />
            </div>
          </div>
          <div class="row actualizaBecas p-1">
            <div class="col-10">
              <div class="row">
                <div class="col-3">
                  <label :for="'visado'" class="form-label-act">Visado:</label>
                  <!--
            <select required v-model="form.visado" class="form-select form-select-sm" :id="'visado'"
              @change="setVisador(usuarioActivo!.id_usuario)">
            -->
                  <select :disabled='!esHabilitadoVisar' required v-model="form.visado" class="form-select form-select-sm"
                    :id="'visado'">
                    <option :value="null" v-html="'--Seleccione--'"></option>
                    <option :key="1" :value="0" v-html="'No'"></option>
                    <option :key="2" :value="1" v-html="'S&iacute;'"></option>
                  </select>
                </div>
                <div class="col" v-show='hayVisado'>
                  <div class="row">
                    <div class="col-5">
                      <label :for='"visador"' class="form-label-act">Visador:</label>
                      <input disabled required type="text" v-model="form.beca!.visador"
                        class="form-control form-control-sm" autocomplete="off" :id='"visador"' />
                    </div>
                    <div class="col-4">
                      <label :for='"fVisado"' class="form-label-act">V&aacute;lido Desde:</label>
                      <input disabled required type="date" v-model="form.beca!.f_visado"
                        class="form-control form-control-sm" autocomplete="off" :id="'fVisado'" />
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="row actualizaBecas p-1" v-show='hayVisado'>
            <div class="col-8">
              <label :for="'expediente'" class="form-label-act">Expediente:</label>
              <input-expediente v-model='form.expediente' :url-server='urlComun' :tipo='"B"'
                :disabled='!esHabilitadoVisar' :disabled-origen='true' :id='"expediente"' class="ms-1" />
            </div>
            <!-- <div class="col-3"> -->
            <div class="col-3" v-show='esVisado'>
              <label :for='"fVencimV"' class="form-label-act">F. Vencimiento:</label>
              <input :disabled='!esHabilitadoVisar' required type="date" v-model="form.beca!.f_vencim_v"
                class="form-control form-control-sm" autocomplete="off" :id="'fVencimV'" />
            </div>
          </div>
          <div class="row actualizaBecas p-1">
            <div class="col-6">
              <label :for='"observaciones"' class="form-label-act">Observaciones:</label>
              <textarea :disabled='!esHabilitadoVisar' v-model="form.beca!.observaciones"
                class="form-control form-control-sm" autocomplete="off" :id="'observaciones'">
        </textarea>
            </div>
          </div>
        </div>
      </fieldset>
    </div>
  </div>
</template>

<script setup lang="ts">

// Librerias
import { DateTime } from "luxon";
import { reactive, computed, ref, toRef, watch, watchEffect, onMounted } from "vue";
import type { Ref } from "vue";
import { AutoComplete, InputExpediente, Expediente, Modal } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import { urlApi, urlComun, isEmpty, loading } from "@/shared.js";
// Componentes
import Historial from "@/components/becas/actualizacion/abm/visado/historial/Grilla.vue";
// Entidades
import Beca from "@/entities/becas/Beca";
import Titulo from "@/entities/becas/Titulo";
import ImpuPresupuestaria from "@/entities/becas/ImpuPresupuestaria";
import Solicitante from "@/entities/Solicitante";
import { Usuariohabilitado } from "@/entities/Usuariohabilitado";
// Stores
import { useTitulosStore } from "@/stores/becas/titulos";
import { useImpuPresupuestariasStore } from "@/stores/becas/impuPresupuestarias";
import { useSolicitantesStore } from "@/stores/solicitantes";
import { usePeriodosStore } from "@/stores/periodos";
import { useUsuariosStore } from "@/stores/usuarios";
import { usePermisosAppStore } from "@/stores/permisosApp";


const titulosStore = useTitulosStore();
const impuPresupuestariasStore = useImpuPresupuestariasStore();
const solicitantesStore = useSolicitantesStore();
const periodosStore = usePeriodosStore();
const usuariosStore = useUsuariosStore();
const permisosAppStore = usePermisosAppStore();

const props = withDefaults(defineProps<{
  beca: Beca | null,
  titulo: Titulo | null,
  mesCertif: Number | null,
  esOpcionAbm: Boolean | null
}>(), {
  beca: null,
  titulo: null,
  mesCertif: null,
  esOpcionAbm: null
});

const emits = defineEmits(["cerrar"]);

const rangoNumeros = (inicio: number, fin: number) => Array.from(Array(fin - inicio + 1).keys()).map((numero: number) => numero + inicio);
const fechaPriDiaMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).startOf('month').toFormat('yyyy-MM-dd') : "";
const fechaUltDiaMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).endOf('month').toFormat('yyyy-MM-dd') : "";
const fechaSigMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).plus({ months: 1 }).toFormat('yyyy-MM-dd') : "";
const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const fechaGetMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).month : NaN;
const mesMostrar = (mes: number) => DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)');
const expedientePorDefecto = (): Expediente => {
  return {
    id: null, origen: "I-A", numero: undefined, anio: String(periodoActivo.value!.anioActivo), alcance: 0
  }
};
/*
const expedienteFormateado = (id_expte_ia: number, clave_exp: string): Expediente => {
  return {
    id: id_expte_ia!, origen: clave_exp!.substring(5, 8), numero: Number(clave_exp!.substring(9, 16)),
    anio: clave_exp!.substring(0, 4), alcance: Number(clave_exp!.substring(17))
  }
};
*/
const expedienteInicial = (id_expte_ia?: number): Expediente => {
  return (!isEmpty(id_expte_ia)) ? {
    id: id_expte_ia!
  } :
    expedientePorDefecto();
};
const esFechaAnterior = (fecha_1: string, fecha_2: string) => DateTime.fromISO(fecha_1).startOf('day') < DateTime.fromISO(fecha_2).startOf('day');

const form = reactive({
  beca: null as Beca | null,
  titulo: null as Titulo | null,
  mesCertif: null as Number | null,
  impuPresupuestaria: null as ImpuPresupuestaria | null,
  responsable: undefined as Solicitante | undefined,
  visado: null as Number | null,
  expediente: {} as Expediente
});

const verModal = computed(() => !isEmpty(form.beca));
const verHistorial = ref(false);
// const verVisar = computed(() => (!isEmpty(props.esOpcionAbm)) && (props.esOpcionAbm === true));
const verVisar = computed(() => (!isEmpty(props.esOpcionAbm)) && (props.esOpcionAbm === true) && (!esEstadoBaja.value) && (!isEmpty(usuarioActivo.value)) && (usuarioActivo.value?.id_perfil === 1));
// const esHabilitadoVisar = computed(() => (!esEstadoBaja.value) && (!isEmpty(usuarioActivo.value)) && (usuarioActivo.value?.id_perfil === 1));
const esHabilitadoVisar = computed(() => (!isEmpty(props.esOpcionAbm)) && (props.esOpcionAbm === true) && (!esEstadoBaja.value) && (!isEmpty(usuarioActivo.value)) && (usuarioActivo.value?.id_perfil === 1));
const esEstadoBaja = computed(() => form.beca?.estado === "B");
const campoMesCertif = computed(() => form.mesCertif);
const hayMesCertif = computed(() => !isEmpty(campoMesCertif.value));
// const esMesCertifValido = computed(() => (hayMesCertif.value && hayFVisado.value) ? (campoMesCertif.value!.valueOf() <= fechaGetMes(form.beca!.f_visado!)) : (false));
const campoVisado = computed(() => form.visado);
const hayVisado = computed(() => !isEmpty(campoVisado.value));
const esVisado = computed(() => (hayVisado.value) && (form.visado === 1));
const hayFVisado = computed(() => !isEmpty(form.beca?.f_visado));
const campoFVencim = computed(() => form.beca?.f_vencim_v);
const hayFVencim = computed(() => !isEmpty(campoFVencim.value));
const hayWatchFVencim = ref(false);
const validarFVencim = ref(false);
const esMesFVencimValido = computed(() => (hayFVencim.value && hayMesCertif.value) ? (fechaGetMes(campoFVencim.value!) >= campoMesCertif.value!.valueOf()) : (false));
const hayFIngreso = computed(() => !isEmpty(form.beca?.f_ingreso));
const hayUltPeriodoLiq = computed(() => !isEmpty(form.beca?.ultimo_periodo_liqui));
const hayPeriodoActivo = computed(() => !isEmpty(periodosStore.periodos.activo));
const usuarioActivo = ref(null) as Ref<Usuariohabilitado | null>;
const ultDiaUltPeriodoLiq = computed(() => hayUltPeriodoLiq.value ? fechaUltDiaMes(form.beca!.ultimo_periodo_liqui) : undefined);
const periodoActivo = computed(() => hayPeriodoActivo.value ? periodosStore.periodos.activo : null);
const ultDiaFPeriodoActivo = computed(() => hayPeriodoActivo.value ? fechaUltDiaMes(periodoActivo.value!.f_periodo) : undefined);
const fVisadoPorDefecto = computed(() => (hayUltPeriodoLiq.value) ?
  (fechaPriDiaMes(fechaSigMes(form.beca!.ultimo_periodo_liqui))) :
  //(hayPeriodoActivo.value ? fechaPriDiaMes(periodoActivo.value!.f_periodo) : undefined)
  (hayFIngreso.value ? fechaPriDiaMes(form.beca!.f_ingreso) : undefined)
);
const fVencimPorCertif = computed(() => (hayMesCertif.value && hayPeriodoActivo.value) ?
  fechaUltDiaMes(String(periodoActivo.value!.anioActivo) + '-' +
    ((campoMesCertif.value!.valueOf() <= 7) ? String(campoMesCertif.value!.valueOf() + 3).padStart(2, "0") : '10') +
    '-01') :
  undefined
);
const hayFVencimPorCertif = computed(() => !isEmpty(fVencimPorCertif.value));
const fVencimPorDefecto = computed(() => hayFVencimPorCertif.value ? fVencimPorCertif.value :
  (hayPeriodoActivo.value ?
    (String(periodoActivo.value!.anioActivo) + ((fechaGetMes(periodoActivo.value!.f_periodo) <= 6) ? '-06-30' : '-12-31')) :
    undefined)
);

/*
watch(hayVisado, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    form.beca!.visador = !isEmpty(form.beca!.visador) ? usuarioActivo.value!.id_usuario : (!isEmpty(props.beca!.visador) ? props.beca!.visador : usuarioActivo.value!.id_usuario);
    form.beca!.f_visado = !isEmpty(form.beca!.f_visado) ? fVisadoPorDefecto.value : (!isEmpty(props.beca!.f_visado) ? props.beca!.f_visado : fVisadoPorDefecto.value);
    expedientePorDefecto();
  }
});

watch(esVisado, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    form.beca!.f_vencim_v = !isEmpty(form.beca!.f_vencim_v) ? fVencimPorDefecto.value : (!isEmpty(props.beca!.f_vencim_v) ? props.beca!.f_vencim_v : fVencimPorDefecto.value);
  }
});
*/


watch(campoVisado, (newValue, oldValue) => {
  if (newValue !== oldValue && hayVisado.value) {
    form.beca!.visador = !isEmpty(form.beca!.visador) ? usuarioActivo.value!.id_usuario : (!isEmpty(props.beca!.visador) ? props.beca!.visador : usuarioActivo.value!.id_usuario);
    form.beca!.f_visado = !isEmpty(form.beca!.f_visado) ? fVisadoPorDefecto.value : (!isEmpty(props.beca!.f_visado) ? props.beca!.f_visado : fVisadoPorDefecto.value);
    if (esVisado.value) {
      expedientePorDefecto();
    }
    /*
    hayWatchFVencim.value = false;
    form.beca!.f_vencim_v = !isEmpty(form.beca!.f_vencim_v) ? fVencimPorDefecto.value : (!isEmpty(props.beca!.f_vencim_v) ? props.beca!.f_vencim_v : fVencimPorDefecto.value);
    */
  }
});

watch([campoMesCertif, campoVisado], ([newMesCertif, newVisado], [oldMesCertif, oldVisado]) => {
  if (((newMesCertif !== oldMesCertif) || (newVisado !== oldVisado)) && (hayMesCertif.value && hayVisado.value)) {
    hayWatchFVencim.value = false;
    form.beca!.f_vencim_v = !isEmpty(form.beca!.f_vencim_v) ? fVencimPorDefecto.value : (!isEmpty(props.beca!.f_vencim_v) ? props.beca!.f_vencim_v : fVencimPorDefecto.value);
  }
});

watch(campoFVencim, (newValue, oldValue) => {
  if ((newValue !== oldValue) && (hayFVencim.value)) {
    if (hayWatchFVencim.value) {
      form.beca!.visador = !isEmpty(form.beca!.visador) ? usuarioActivo.value!.id_usuario : (!isEmpty(props.beca!.visador) ? props.beca!.visador : usuarioActivo.value!.id_usuario);
      form.beca!.f_visado = !isEmpty(form.beca!.f_visado) ? fVisadoPorDefecto.value : (!isEmpty(props.beca!.f_visado) ? props.beca!.f_visado : fVisadoPorDefecto.value);
    } else {
      hayWatchFVencim.value = true;
    }
    if (newValue !== props.beca!.f_vencim_v) {
      validarFVencim.value = true;
    }
  }
});

onMounted(async () => {
  loading.show();
  await cargar();
  loading.hide();
});

async function cargar() {
  const cImpuPresupuestaria: string = (!isEmpty(props.beca!.impu_presupuestaria)) ? props.beca!.impu_presupuestaria : "P";
  const idUsuarioActivo: string = permisosAppStore.currentUser!.id_usuario!;
  let promises: Promise<unknown>[] = [];
  let promiseImpuPresupuestaria: Promise<ImpuPresupuestaria | null>;
  let promiseSolicitanteResp: Promise<Solicitante | null>;
  let promiseUsuarioHab: Promise<Usuariohabilitado | null>;
  let solicitanteResp: Solicitante | null;
  form.expediente = expedienteInicial(props.beca!.id_expte_ia);
  promiseImpuPresupuestaria = impuPresupuestariasStore.findImpuPresupuestaria(cImpuPresupuestaria);
  promiseUsuarioHab = usuariosStore.findUsuarioByIdUsuario(idUsuarioActivo);
  promises.push(promiseImpuPresupuestaria, promiseUsuarioHab);
  if (!isEmpty(props.beca!.id_tabla_sol_responsable)) {
    promiseSolicitanteResp = solicitantesStore.findSolicOProyecto(props.beca!.id_tabla_sol_responsable);
    promises.push(promiseSolicitanteResp);
  }
  await Promise.all(promises).then(async (values) => {
    if (!Swal.isVisible()) {
      usuarioActivo.value = await promiseUsuarioHab;
      usuarioActivo.value!.id_perfil = Number(usuarioActivo.value?.id_perfil);
      form.beca = Object.assign(new Beca(), props.beca);
      form.impuPresupuestaria = await promiseImpuPresupuestaria;
      solicitanteResp = promises.includes(promiseSolicitanteResp) ? (await promiseSolicitanteResp) : null;
      form.responsable = (solicitanteResp !== null) ? solicitanteResp : undefined;
      form.titulo = props.titulo;
      form.mesCertif = props.mesCertif;
      form.beca.visador = undefined;
      form.beca.f_visado = undefined;
      form.beca.f_vencim_v = undefined;
      form.visado = !isEmpty(props.beca!.visado) ? props.beca!.visado : null;
      /*
      setVisador(!isEmpty(props.beca!.visado) ? props.beca!.visador : usuarioActivo.value!.id_usuario);
      form.beca.f_visado = !isEmpty(props.beca!.f_visado) ? props.beca!.f_visado : fechaPriDiaMesAct();      
      form.expediente = (!isEmpty(props.beca!.id_expte_ia) && !isEmpty(props.beca!.clave_exp)) ?
        expedienteFormateado(props.beca!.id_expte_ia, props.beca!.clave_exp) :
        expedientePorDefecto();
        */
    }
    //loading.hide();
  }).catch(function () {
    //loading.hide();
  });
}

/*
function setVisador(visador: string) {
  form.beca!.visador = visador;
}
*/

function abrirHistorial() {
  verHistorial.value = true;
}

function cerrarHistorial() {
  verHistorial.value = false;
}

function validar() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (isEmpty(form.titulo)) {
    swal.html = "Por favor, seleccione el t&iacute;tulo del becario.";
  } else if (!hayMesCertif.value) {
    swal.html = 'Por favor, seleccione el mes del certificado del becario, correspondiente al campo "Mes Certif.".';
  } else if (isEmpty(form.beca!.establecimiento_cursa)) {
    swal.html = 'Por favor, complete el establecimiento en el que cursa el becario, correspondiente al campo "Cursa en".';
  } else if (isEmpty(form.impuPresupuestaria)) {
    swal.html = "Por favor, seleccione la imputaci&oacute;n presupuestaria de la beca.";
  } else if (!hayVisado.value) {
    swal.html = 'Por favor, seleccione una opci&oacute;n v&aacute;lida para el campo "Visado" de la beca ("S&iacute;" o "No").';
  } else if (isEmpty(form.beca!.visador)) {
    swal.html = 'El visador de la beca debe ser un usuario v&aacute;lido del sistema. Por favor, avise al Administrador.';
  } else if (isEmpty(form.beca!.f_visado)) {
    swal.html = 'La fecha de visado de la beca, correspondiente al campo "V&aacute;lido Desde", no posee un valor v&aacute;lido. Por favor, avise al Administrador.';
  } else if (isEmpty(form.expediente.id)) {
    swal.html = 'Por favor, complete el expediente correspondiente al visado de la beca.';
  }
  //else if (esVisado.value) {
  // if (isEmpty(form.beca!.f_vencim_v)) {
  //else if (!hayFVencim.value) {
  else if (esVisado.value && !hayFVencim.value) {
    swal.html = 'Por favor, complete la fecha de vencimiento del visado de la beca.';
  } /* else if (!esMesCertifValido.value) {
    swal.html = 'Por favor, compruebe que el mes del certificado del becario, informado en el campo "Mes Certif.", sea anterior o igual al mes de la fecha de visado de la beca, correspondiente al campo "V&aacute;lido Desde".';
  } */ else if (esVisado.value) {
    if (!esMesFVencimValido.value) {
      swal.html = 'Por favor, compruebe que el mes correspondiente a la fecha de vencimiento del visado de la beca sea igual o posterior al mes del certificado del becario, informado en el campo "Mes Certif.".';
    } else if (esFechaAnterior(campoFVencim.value!, form.beca!.f_visado!)) {
      swal.html = 'Por favor, compruebe que la fecha de vencimiento del visado de la beca sea igual o posterior a la fecha del visado de la beca, informada en el campo "V&aacute;lido Desde" (' + fechaMostrar(form.beca!.f_visado!) + ').';
    } else if (validarFVencim.value) {
      if (hayUltPeriodoLiq.value && esFechaAnterior(campoFVencim.value!, ultDiaUltPeriodoLiq.value!)) {
        swal.html = 'Por favor, compruebe que la fecha de vencimiento del visado de la beca sea igual o posterior al &uacute;ltimo d&iacute;a del &uacute;ltimo per&iacute;odo liquidado (' + fechaMostrar(ultDiaUltPeriodoLiq.value!) + ').';
      } else if (hayPeriodoActivo.value && esFechaAnterior(campoFVencim.value!, ultDiaFPeriodoActivo.value!)) {
        swal.html = 'Por favor, compruebe que la fecha de vencimiento del visado de la beca sea igual o posterior al &uacute;ltimo d&iacute;a del per&iacute;odo activo (' + fechaMostrar(ultDiaFPeriodoActivo.value!) + ').';
      }
    }
  }
  //}
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  visar();
}


function visar() {
  const url: string = "authorizeBeca";
  const paramsRequest: any = {
    id_beca: form.beca?.id_beca,
    id_tabla_sol: form.beca?.id_tabla_sol,
    id_becario_beca: form.beca?.id_becario_beca,
    id_becario_apod: form.beca?.id_becario_apod,
    f_ingreso: form.beca?.f_ingreso,
    f_egreso: form.beca?.f_egreso,
    id_titulo: form.titulo?.id_titulo,
    establecimiento_cursa: form.beca?.establecimiento_cursa,
    mes_certif: form.mesCertif,
    impu_presupuestaria: form.impuPresupuestaria?.c_impu_presupuestaria,
    id_tabla_sol_responsable: form.responsable?.id_tabla_sol,
    visado: form.visado,
    //visador: form.beca!.visador,
    f_visado: form.beca?.f_visado,
    id_expte_ia: form.expediente.id,
    //f_vencim_v: form.beca?.f_vencim_v,    
    f_vencim_v: esVisado.value ? form.beca?.f_vencim_v : null,
    observaciones: form.beca?.observaciones
  };
  guardar(url, paramsRequest);
}

async function guardar(url: string, paramsRequest: any) {
  /*
  const swal_exito: SweetAlertOptions<any, any> = {
    icon: "success",
    title: "&Eacute;xito",
    html: "",
    showConfirmButton: false,
    timer: 500,
  };
  */
  const swal_error: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  loading.show();
  await http
    .post<any>(urlApi + url, paramsRequest)
    .then(function (response: AxiosResponse<any, any>) {
      form.beca!.id_beca = !isEmpty(response.data.id_out) ? Number(response.data.id_out) : response.data.id_out;
      //swal_exito.html = response.data.mensaje_out;
      //loading.hide();
      /*
      Swal.fire(swal_exito).then(function (result: SweetAlertResult<any>) {
        if (result.dismiss === Swal.DismissReason.timer) {
          //console.log("I was closed by the timer")
          cerrar();
        }
      });
      */
      cerrar(response.data.mensaje_out);
    })
    .catch(function (error: AxiosError<string, any>) {
      if (error.response) {
        // Request made and server responded
        /*
        if (error.response.data.indexOf("|") !== -1) {
          swal_error.html = error.response.data.substring(
            error.response.data.indexOf("|") + 2,
            error.response.data.indexOf("Código") - 8
          );
        } else {
          swal_error.html =
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + ("<h2>").length,
              error.response.data.indexOf("</h2>")
            );
        }
        */
        swal_error.html = error.response.data;
        console.log("Error: request made and server responded");
        console.log(swal_error.html);
        console.log(error.response);
        //console.log(error.response.status);
        //console.log(error.response.headers);
        //console.log(error.response.data);
      } else if (error.request) {
        // The request was made but no response was received
        swal_error.html =
          "Error desconocido. Por favor, avise al Administrador.";
        console.log("Error: the request was made but no response was received");
        console.log(error.request);
      } else {
        // Something happened in setting up the request that triggered an Error
        swal_error.html =
          "Error desconocido. Por favor, avise al Administrador.";
        console.log(
          "Error: something happened in setting up the request that triggered an error"
        );
        console.log(error);
      }
      loading.hide();
      Swal.fire(swal_error);
    });
}

function cerrar(mensaje_out: string) {
  emits("cerrar", mensaje_out);
}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
